<template>
    <div
            id="app"
            class="app-container"
    >
        <pageHeader
                class="sticky"
                ref="pageHeader"
                v-bind:surveytitle="questionnaire.surveytitle"
                v-bind:progress="computeProgress"
        ></pageHeader>
        <pageContent
                v-bind:pageIndex="pageIndex"
                v-bind:welcomePage="questionnaire.welcomePage"
                v-bind:gdprNotice="questionnaire.gdprNotice"
                v-bind:questionset="questionnaire.questionset"
                v-bind:questionIndex="questionIndex"
                v-bind:gdprAccepted="gdprAccepted"
                v-bind:endPage="questionnaire.endPage"
                v-bind:answerset="answerset"
        ></pageContent>
        <span ref="warning" class="warning">{{pageNotCompletelyFilledOutWarning}}</span>
        <div class="content-margin" v-if="pageIndex !== 3"></div>
        <navigationBar
                v-bind:pageIndex="pageIndex"
                v-bind:questionIndex="questionIndex"
                v-bind:gdprAccepted="gdprAccepted"
                v-on:clickedNext="nextPage"
                v-on:clickedPrevious="previousPage"
                v-on:showWelcomePage="showWelcomePage"
                v-on:showGDPRNotice="showGDPRNotice"
        ></navigationBar>
    </div>
</template>

<script>
    import PageHeader from './PageHeader.vue';
    import PageContent from './Content.vue';
    import NavigationBar from './NavigationBar.vue';

    let axios = require('axios');
    const scrollTo = require('vue-scrollto').scrollTo;

    //sum up to and excluding index
    function sumTo(array, index) {
        let sum = 0;
        for (let i = 0; i < index && i < array.length; i++) {
            sum += array[i];
        }
        return sum;
    }

    function addAnsweroptionPage(answeroption, index, answeroptionPages) {
        const type = typeof(answeroption);
        if (type !== "object") {
            return;
        }

        answeroptionPages[answeroption.id] = index;
        if (type === "checkbox" || type === "radiobutton" || type === "compose") {
            for (const option of answeroption.options) {
                addAnsweroptionPage(option, index, answeroptionPages);
            }
        }
    }

    //time per question - used for intelligent progress bar
    const costs = [15, 15, 30, 10, 15, 60, 15, 90, 90, 90, 60, 45, 15, 25, 60, 60, 15, 30, 20, 60, 60, 15, 60, 30, 45, 60, 60];

    export default {
        name: 'app',
        components: {
            PageHeader, PageContent, NavigationBar
        },
        methods: {
            updatePageCache() {
                try {
                    let tmp = JSON.parse(localStorage[this.qid]);
                    tmp.pageIndex = this.pageIndex;
                    tmp.questionIndex = this.questionIndex;
                    localStorage[this.qid] = JSON.stringify(tmp);
                    console.log(this.pageIndex, " ", this.questionIndex);
                } catch (err) {
                    console.log(`penis ${err.toString()}`);
                }
            },
            previousPage() {
                this.pageNotCompletelyFilledOutWarning = "";
                if (this.pageIndex === 2) {
                    this.submitAnswerset();
                }

                if (this.pageIndex === 1) {
                    this.gdprAccepted = false;
                } else if (this.pageIndex !== 2) {
                    this.pageIndex = (this.pageIndex + this.contentArray.length - 1) % this.contentArray.length;
                    if (this.pageIndex === 2) {
                        this.questionIndex = this.questionnaire.questionset.length - 1;
                    }
                } else if (this.questionIndex === 0 && this.pageIndex === 2) {
                    this.pageIndex--;
                } else if (this.questionIndex > 0 && this.pageIndex === 2) {
                    this.questionIndex--;
                }

                scrollTo(this);
                this.updatePageCache();
            },
            nextPage() {
                this.pageNotCompletelyFilledOutWarning = "";
                if (!this.canGoToNextPage()) {
                    this.pageNotCompletelyFilledOutWarning = "Bitte fülle die aktuelle Seite komplett aus.";
                    scrollTo(this.$refs.warning);
                    return;
                }

                if (this.pageIndex === 2) {
                    this.submitAnswerset();
                }

                if (this.pageIndex !== 2) {
                    this.pageIndex = (this.pageIndex + 1) % this.contentArray.length;
                    if (this.pageIndex === 2) {
                        this.questionIndex = 0;
                    }
                } else if (this.questionIndex < this.questionnaire.questionset.length - 1 && this.pageIndex === 2) {
                    this.questionIndex++;
                } else if (this.questionIndex === this.questionnaire.questionset.length - 1 && this.pageIndex === 2) {
                    this.pageIndex++;
                    this.questionIndex++;
                }

                scrollTo(this);
                this.updatePageCache();
            },
            showWelcomePage() {
                this.gdprAccepted = true;
                this.pageIndex = 0;
            },
            showGDPRNotice() {
                this.gdprAccepted = true;
                this.pageIndex = 1;
            },
            /* scheduled to add feature in next version */
            autocloseMenu() {
                this.$refs.pageHeader.sidebarVisible = false;
            },
            submitAnswerset() {
                axios.post(`https://${window.location.host}/api/questionnaires/${this.qid}/answers?uid=${this.uid}`, {"answerset": this.answerset}).then((response) => {
                    //alert("posted " + this.answerset.length + " elements");
                }).catch((error) => {
                    //alert(error);
                });
            },
            canGoToNextPage() {
                //true if all questions filled out on current page
                if (this.pageIndex !== 2) {
                    return true;
                }

                const pageAnsweroptions = this.questionnaire.questionset[this.questionIndex].answers;
                const answerset = this.answerset;

                function isFilledOut(answeroption) {
                    if (typeof(answeroption) !== "object") {
                        return true;
                    }

                    const type = answeroption.type;
                    const index = answerset.findIndex(x => x.id === answeroption.id);

                    if (type === "radiobutton-matrix") {
                        if (index === -1 || answerset[index].value.length !== answeroption.options.length) {
                            return false;
                        }
                        //console.log(JSON.stringify(answerset[index]));
                    } else if (type === 'radiobutton' /*|| type === 'freetext'*/ || type === 'dropdown') {
                        if (index === -1) {
                            return false;
                        }
                    } else if (type === 'compose') {
                        for (const option of answeroption.options) {
                            if (!isFilledOut(option)) {
                                return false;
                            }
                        }
                    }

                    return true;
                }

                for (const answeroption of pageAnsweroptions) {
                    if (!isFilledOut(answeroption)) {
                        return false;
                    }
                }
                return true;
            }
        },
        computed: {
            computeProgress: function () {
                let constantProgress = this.questionIndex / this.questionnaire.questionset.length;
                switch (this.progressBarType) {
                    case "none":
                        return 0;
                    case "linear":
                        return constantProgress;
                    case "slow-to-fast":
                        return Math.pow(constantProgress + (1 - constantProgress) * 0.03, 2);
                    case "fast-to-slow":
                        return 1 - Math.pow(1 - constantProgress, 1.5);
                    case "smart":
                        if (this.pageIndex === 3)
                            return 1;
                        return sumTo(costs, this.questionIndex) / sumTo(costs, costs.length);
                    default:
                        return 0;
                }
            },
        },
        data() {
            return {
                qid: "",
                uid: "",
                answerset: [],
                gdprAccepted: true,
                pageNotCompletelyFilledOutWarning: "",
                pageIndex: 0,
                questionIndex: 0,
                progressBarType: "none",
                contentArray: ['welcomePage', 'gdprNotice', 'questionset', 'endPage'],
                /* until backend and frontend are linked, insert generated questionnaire-data here */
                questionnaire: {
                    "id": -1,
                    "surveytitle": "Fragebogen wird geladen...",
                    "welcomePage": "<h1>Fragebogen wird geladen...</h1><br>Sollte dieser Text länger lesbar sein, ist ein Fehler aufgetreten. Überprüfen Sie in diesem Fall den Link oder laden Sie die Seite neu. Sollte der Fehler auch dann noch bestehen, wenden Sie sich bitte an fachgruppe@informatik.uni-goettingen.de<br><br>Fehlercode 444",
                    "questionset": [{
                        'id': 0,
                        'questiontext': "loading question...",
                        'answers': [],
                    }]
                }
            };
        },
        mounted() {
            let getParamsFromSearch = function (url) {
                let params = {};
                let query = url.substr(1);
                let vars = query.split('&').filter((s) => s !== '');
                for (let i = 0; i < vars.length; i++) {
                    let pair = vars[i].split('=');
                    params[pair[0]] = decodeURIComponent(pair[1]);
                }
                return params;
            };

            const qid = getParamsFromSearch(window.location.search).qid;
            const uid = getParamsFromSearch(window.location.search).uid;
            if (qid === undefined || uid === undefined)
                throw new Error('missing qid, uid or otherwise currupt url');

            if (typeof localStorage[qid] === "string") {
                let tmp = JSON.parse(localStorage[qid]);
                this.pageIndex = tmp.pageIndex;
                this.questionIndex = tmp.questionIndex;
                localStorage[qid] = JSON.stringify(tmp);
            } else {
                localStorage[qid] = JSON.stringify({
                    href: location.href,
                    pageIndex: this.pageIndex,
                    questionIndex: this.pageIndex
                });
            }

            axios.get(`https://${window.location.host}/api/questionnaires/${qid}?uid=${uid}`).then((response) => {
                this.questionnaire = response.data;

                const answeroptionPages = {};
                for (const i in this.questionnaire.questionset) {
                    for (const a of this.questionnaire.questionset[i].answers) {
                        addAnsweroptionPage(a, i, answeroptionPages);
                    }
                }

                axios.get(`https://${window.location.host}/api/questionnaires/${qid}/answers?uid=${uid}`).then((response) => {
                    this.answerset = response.data.answerset;

                    const max = (x, y) => x < y ? y : x;
                    const maxPage = this.answerset.map(x => answeroptionPages[x.id]).reduce(max, -1);

                    // if (maxPage !== -1) {
                    //     this.pageIndex = 2;
                    //     this.questionIndex = maxPage;
                    // }
                }).catch(function (error) {
                    this.answerset = [];
                    throw error;
                });
            }).catch(function (error) {
                throw error;
            });

            axios.get(`https://${window.location.host}/api/questionnaires/${qid}/progressbar?uid=${uid}`).then((response) => {
                this.progressBarType = response.data.progressbarType;
            }).catch(function (error) {
                throw error;
            });

            this.qid = qid;
            this.uid = uid;
        }
    };
</script>

<style>
    /* non-media query used for standard-desktop-scale */
    html {
        background-color: #FAFAFA;
        height: 100%;
        min-height: 300px;
        min-width: 200px;
    }

    body {
        margin: 0;
        height: inherit;
    }

    .app-container {
        font-family: 'Avenir', Helvetica, Arial, sans-serif;
        -webkit-font-smoothing: antialiased;
        -moz-osx-font-smoothing: grayscale;
        text-align: center;
        color: #002d13;
        background-color: transparent;
        height: inherit;
    }


    /* Sticky class for pageHeader */
    .sticky {
      position: fixed;
      top: 0;
      width: 100%;
      z-index: 1000;
    }


    pageContent, pageHeader, navigationBar {
        display: block;
    }

    .content-margin {
        /* Derived from navigation-bar height: 80px is button height + 40px */
        height: 80px;
    }

    .questionTitle, .navigation > .button, .pageHeader {
        background-color: #1B5E20;
        color: ghostwhite;
    }

    img {
        max-width: 100%;
    }

    /* desktop screen-size
          width > 1028px
          height > 900px
    */

    /* Screen width <= 1028px -> touchable but screen-layout */
    @media screen and (max-width: 1028px) {
      /* template for fix breakpoint */
    }

    /* Screen height <= 700px */
    @media screen and (max-height: 700px) {
        html {
            background-color: #E8F5E9;
        }

    }

    /* On screens that are 700px or less -> mobile layout */
    @media screen and (max-width: 800px) {
        html {
            background-color: #E8F5E9;
        }
    }

    /* Screen height <= 600px -> assumed touchable-landscape */
    @media screen and (max-height: 400px) {
      /* template for fix breakpoint */
    }


    /* styles for list-answertypes:
        * radiobutton
        * checkbox
        * matrix-x
        * dropdown
    */

    .listing {
        background-color: transparent;
        padding-top: 1vw;
        padding-bottom: 1vw;
    }

    .listing:nth-child(2n) {
        background-color: #81C784;
        padding-left: 1ch;
    }

    .listing:nth-child(2n+1) {
        background-color: #A5D6A7;
        padding-left: 1ch;
    }

    .listing > *:hover, .listing.answer:hover, .checked {
        background-color: #43A047;
        cursor: pointer
    }

    .listing > *.nohover {
        background-color: transparent;
    }

    /* left align: dropdown menus */
    select {
      float: left;
    }

    /* style for scrollbars */

    ::-webkit-scrollbar {
        -webkit-appearance: none !important;
    }

    ::-webkit-scrollbar:vertical {
        width: 6px !important;
    }

    ::-webkit-scrollbar:horizontal {
        height: 6px !important;
    }

    /* Track */
    ::-webkit-scrollbar-track {
        -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3) !important;
    }

    /* Handle */
    ::-webkit-scrollbar-thumb {
        background-color: #1B5E20 !important;
        -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3) !important;
    }

    /* styling for warning-texts */
    .warning {
        color: red;
        margin-top: 2em;
    }

</style>
